
	EventSounds = {}
	EventSounds.AddonMenu = LibStub:GetLibrary("LibCustomAddonMenu-1.0")
	EventSounds.RvRLib = LibStub:GetLibrary("RvRLib-1.0")
	EventSounds.SavedVars = {}
	EventSounds.SoundList = {

		"DIALOG_ACCEPT",
		"DIALOG_DECLINE",

  		"CLOTHIER_IMPROVE_TOOLTIP_GLOW_FAIL",
  		"CLOTHIER_IMPROVE_TOOLTIP_GLOW_SUCCESS", 

  		"WOODWORKER_IMPROVE_TOOLTIP_GLOW_FAIL",
  		"WOODWORKER_IMPROVE_TOOLTIP_GLOW_SUCCESS", 

  		"BLACKSMITH_IMPROVE_TOOLTIP_GLOW_FAIL",
  		"BLACKSMITH_IMPROVE_TOOLTIP_GLOW_SUCCESS", 

  		"ALCHEMY_CREATE_TOOLTIP_GLOW_FAIL",
  		"ALCHEMY_CREATE_TOOLTIP_GLOW_SUCCESS", 

  		"SMITHING_FINISH_RESEARCH",
		"STATS_PURCHASE",
		"STORE_WINDOW_BUY_CLICKED",

		"BOOK_ACQUIRED",
		"BOOK_CLOSE",
		"BOOK_COLLECTION_COMPLETED",
		"BOOK_OPEN",
		"BOOK_PAGE_TURN",

  		"AVA_GATE_CLOSED",
  		"AVA_GATE_OPENED",
  		"ACHIEVEMENT_AWARDED",	
  		"LEVEL_UP",

  		"LOCKPICKING_BREAK", 
  		"LOCKPICKING_UNLOCKED", 
  		"LOCKPICKING_NO_LOCKPICKS", 
  		"LOCKPICKING_SUCCESS_CELEBRATION",

  		"MAIL_SENT", 
  		"MAIL_ITEM_DELETED", 
  		"MAIL_ITEM_SELECTED", 
  		"NEW_MAIL", 
  		"NEW_NOTIFICATION",

  		"OBJECTIVE_ACCEPTED",
  		"OBJECTIVE_COMPLETED", 
  		"OBJECTIVE_DISCOVERED", 

		"GROUP_JOIN", 
		"GROUP_LEAVE",


		"PLAYER_ACTION_INSUFFICIENT_GOLD",
		"ITEM_MONEY_CHANGED",

	    "EMPEROR_CORONATED_ALDMERI",
	  	"EMPEROR_CORONATED_DAGGERFALL",
	  	"EMPEROR_CORONATED_EBONHEART",
	  	"EMPEROR_DEPOSED_ALDMERI",
	  	"EMPEROR_DEPOSED_DAGGERFALL",
	  	"EMPEROR_DEPOSED_EBONHEART",
  		"ELDER_SCROLL_CAPTURED_BY_ALDMERI",
 	 	"ELDER_SCROLL_CAPTURED_BY_DAGGERFALL",
 		"ELDER_SCROLL_CAPTURED_BY_EBONHEART",

	}
	local DefaultSettings =
	{
		["OnWhisperReceived"] = "NEW_NOTIFICATION",
		["OnKeepCaptured"] = "OBJECTIVE_COMPLETED",
		["OnKeepDefended"] = "OBJECTIVE_COMPLETED",
		["HPLIMIT"] = 50,
		["HPDelay"] = 5,
		["OnHPLimit"] = "ELDER_SCROLL_CAPTURED_BY_ALDMERI",
	}
	local function InitializeAddon(eventID, addonName)
		if addonName == "EventSounds" then
			EventSounds.SavedVars = ZO_SavedVars:New( 'EventSounds_SavedVars', 1, nil, DefaultSettings)	
			Initialize_Events()
			EventSounds:Initialize_Menu()
		end
	end

	function Initialize_Events( )
		EVENT_MANAGER:RegisterForEvent("EventSounds", EVENT_CHAT_MESSAGE_CHANNEL , function(...) EventSounds:onChatReceived(...) end);
		EVENT_MANAGER:RegisterForEvent("EventSounds", EVENT_KEEP_ALLIANCE_OWNER_CHANGED , function(...) EventSounds:onKeepCaptured(...) end);
		EVENT_MANAGER:RegisterForEvent("EventSounds", EVENT_KEEP_UNDER_ATTACK_CHANGED , function(...) EventSounds:onKeepDefended(...) end);
	end


	function EventSounds:OnUpdate()
		if EventSounds.Group then
			EventSounds.Group:onUpdate()
		end
	end

	function EventSounds:Initialize_Menu()
		local panelID = self.AddonMenu:CreateControlPanel("EventSoundsMenu", "|c50738DEvent Sounds")
		local _prefix = "ES_"
		self.AddonMenu:AddHeader(panelID, _prefix .. "HEADER", "|c50738DEvent Sounds")

		self.AddonMenu:AddPlayDropdown(panelID, _prefix .. "WHISP_SOUND", "On Whisper Received, Play Sound: ", "", self.SoundList,
        function()
        	return self.SavedVars.OnWhisperReceived
        end, 
        function(value)
        	self.SavedVars.OnWhisperReceived = value
        end,
		true,
			self.SavedVars.OnWhisperReceived)

		self.AddonMenu:AddPlayDropdown(panelID, _prefix .. "OnKeepCaptured_SOUND", "On Keep Captured, Play Sound: ", "", self.SoundList,
        function()
        	return self.SavedVars.OnKeepCaptured
        end, 
        function(value)
        	self.SavedVars.OnKeepCaptured = value
        end, 
		true,
			self.SavedVars.OnKeepCaptured)

		self.AddonMenu:AddPlayDropdown(panelID, _prefix .. "OnKeepDefended_SOUND", "On Keep Defended, Play Sound: ", "", self.SoundList,
        function()
        	return self.SavedVars.OnKeepDefended
        end, 
        function(value)
        	self.SavedVars.OnKeepDefended = value
        end,
		true,
			self.SavedVars.OnKeepDefended)


		self.AddonMenu:AddDescription(panelID, _prefix .. "SLIDER_HP_DESC", "|cD9A037Combat Sounds")

		self.AddonMenu:AddSlider(panelID,  _prefix .. "SLIDER_HP", "HP Limit in Percent", "", 0, 100, 1, function() return self.SavedVars.HPLIMIT end, function(value) self.SavedVars.HPLIMIT = value end,true)
		self.AddonMenu:AddPlayDropdown(panelID, _prefix .. "DROPDOWN_HP", "When under HP Limit, Play Sound: ", "", self.SoundList,
        function()
        	return self.SavedVars.OnHPLimit
        end, 
        function(value)
        	self.SavedVars.OnHPLimit = value
        end,
		true,
			self.SavedVars.OnHPLimit)

		self.AddonMenu:AddSlider(panelID,  _prefix .. "SLIDER_HPDelay", "Delay between two sounds", "", 2, 30, 1, function() return self.SavedVars.HPDelay end, function(value) self.SavedVars.HPDelay = value end)

	end


	function EventSounds:onChatReceived( eventID, messageType, sender, text )
		if messageType == CHAT_CHANNEL_WHISPER then
			PlaySound(SOUNDS[self.SavedVars.OnWhisperReceived])
		end		
	end

	function EventSounds:onKeepCaputred( eventID, messageType, sender, text )
		if messageType == CHAT_CHANNEL_WHISPER then
			PlaySound(SOUNDS[self.SavedVars.OnWhisperReceived])
		end		
	end

	function EventSounds:onKeepDefended( eventID, messageType, sender, text )
		if messageType == CHAT_CHANNEL_WHISPER then
			PlaySound(SOUNDS[self.SavedVars.OnWhisperReceived])
		end		
	end
	EVENT_MANAGER:RegisterForEvent("EventSounds", EVENT_ADD_ON_LOADED, InitializeAddon)



EventSounds.LastKeepCaputred = nil
function EventSounds:onKeepCaptured( eventID, argKeepID, oldAlliance, newAlliance) 
	if newAlliance == GetUnitAlliance("player") then 
		if EventSounds.RvRLib:PlayerIsNearKeepID(argKeepID,AREA_SQUARE) then
			PlaySound(SOUNDS[self.SavedVars.OnKeepCaptured])	
		end
	end
	EventSounds.LastKeepCaputred = argKeepID
	zo_callLater(function() EventSounds.LastKeepCaputred = nil end, 30000) 
end

EventSounds.LastKeepDefended = nil
function EventSounds:onKeepDefended(eventID, argKeepID, Status)
	if EventSounds.LastKeepCaputred == argKeepID then return end
	zo_callLater(function() EventSounds.LastKeepCaputred = nil end, 30000) 
	local CurrentBattlegroundContext = EventSounds.RvRLib:getBattlegroundContext()	
	if GetKeepUnderAttack(argKeepID,CurrentBattlegroundContext) then return end
	local keepAlliance = GetKeepAlliance(argKeepID, CurrentBattlegroundContext)
	if keepAlliance ~= GetUnitAlliance('player') then return end
	
	if EventSounds.RvRLib:PlayerIsNearKeepID(argKeepID,AREA_SQUARE) then
		PlaySound(SOUNDS[self.SavedVars.OnKeepDefended])		
	end
end


SLASH_COMMANDS["/sd"] = function (extra)
  PlaySound(SOUNDS[extra])
end
